Attribute VB_Name = "ModMoves"
'/*
' * Copyright 1999-2004 by Michel D. Grimminck
' *
' * All Rights Reserved
' *
' * Permission to use, copy, modify, and distribute this software and its
' * documentation for any purpose and without fee is hereby granted,
' * provided that the above copyright notice appear in all copies and that
' * both that copyright notice and this permission notice appear in
' * supporting documentation.
' *
' * This program is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' *
' * Please read GPL.html for the full license text.
' */

Public cBoard(MAXDIST1) As Integer
Public gCcTop As Integer
Public gCCBot As Integer
Public gScore As Single
Public movesMaxDist  As Integer
Private bestScore As Single
Dim tmovedone(MAXDIST1) As Integer
Dim bmovedone(MAXDIST1) As Integer
Public moveList(1296) As Long
Public moveListCount As Long

Private Sub Form_Load()
    
    Call initboard
    Debug.Print "Starting"
    Debug.Print pboard()
    Debug.Print
    Call doAllMoves(6, 5)
End Sub

Sub initboard()
    cBoard(1) = 2
    cBoard(2) = 2
    cBoard(3) = 0
    cBoard(4) = 2
    cBoard(5) = 2
    cBoard(6) = 2
End Sub
Function pboard()
    Dim pip As Long
    pip = 0
    For i = 1 To movesMaxDist
        pboard = pboard & cBoard(i)
        pip = pip + cBoard(i) * i
        If i = 6 Then pboard = pboard & " "
    Next
    pboard = pboard & "   " & pip
End Function
Sub doAllMoves(d1 As Integer, d2 As Integer)
    'frmSolve.List1.AddItem (d1 & " " & d2)
    gScore = 999 'pick best score
    If d1 = d2 Then
        Call doDoubleMoves(d1)
    Else
        Call doSingleMoves(d1, d2)
        Call doSingleMoves(d2, d1)
    End If
    'gScore = gScore + bestScore
    'frmSolve.List1.AddItem gScore
End Sub
Sub doSingleMoves(d1 As Integer, d2 As Integer)
    Dim i1 As Integer
    Dim i2 As Integer
    Dim t1(MAXDIST1) As Integer
    Dim t2(MAXDIST1) As Integer
    Dim secondMove As Boolean
    Dim i As Integer
    For i = 1 To movesMaxDist: t1(i) = cBoard(i): Next
    For i1 = 1 To movesMaxDist
        If cBoard(i1) > 0 Then
            If tryMove(i1, d1) Then
                secondMove = False
                For i = 1 To movesMaxDist: t2(i) = cBoard(i): Next
                For i2 = 1 To movesMaxDist
                    If cBoard(i2) > 0 Then
                        If tryMove(i2, d2) Then
                            Call moveDone
                            secondMove = True
                        End If
                        For i = 1 To movesMaxDist: cBoard(i) = t2(i): Next
                    End If
                Next
                If Not secondMove Then 'apparently only one checker can be moved
                    Call moveDone
                End If
            End If
            For i = 1 To movesMaxDist: cBoard(i) = t1(i): Next
        End If
    Next
End Sub
Sub doDoubleMoves(d1 As Integer)
    Dim t1(MAXDIST1) As Integer
    Dim t2(MAXDIST1) As Integer
    Dim t3(MAXDIST1) As Integer
    Dim t4(MAXDIST1) As Integer
    Dim i1 As Integer
    Dim i2 As Integer
    Dim i3 As Integer
    Dim i4 As Integer
    Dim secondMove As Boolean
    Dim i As Integer
    Dim thirdMove As Boolean
    Dim fourthMove As Boolean
    For i = 1 To movesMaxDist: t1(i) = cBoard(i): Next
    For i1 = 1 To movesMaxDist
        If cBoard(i1) > 0 Then
            If tryMove(i1, d1) Then
                secondMove = False
                For i = 1 To movesMaxDist: t2(i) = cBoard(i): Next
                For i2 = 1 To movesMaxDist
                    If cBoard(i2) > 0 Then
                        If tryMove(i2, d1) Then
                            secondMove = True
                            'third checker
                            thirdMove = False
                            For i = 1 To movesMaxDist: t3(i) = cBoard(i): Next
                            For i3 = 1 To movesMaxDist
                                If cBoard(i3) > 0 Then
                                    If tryMove(i3, d1) Then
                                        fourthMove = False
                                        For i = 1 To movesMaxDist: t4(i) = cBoard(i): Next
                                        For i4 = 1 To movesMaxDist
                                            If cBoard(i4) > 0 Then
                                                If tryMove(i4, d1) Then
                                                    Call moveDone
                                                    For i = 1 To movesMaxDist: cBoard(i) = t4(i): Next
                                                    fourthMove = True
                                                End If
                                            End If
                                        Next
                                        'Debug.Print pboard()
                                        thirdMove = True
                                        If Not fourthMove Then
                                            Call moveDone
                                        End If
                                        For i = 1 To movesMaxDist: cBoard(i) = t3(i): Next
                                    End If
                                End If
                            Next
                            secondMove = True
                            If Not thirdMove Then
                                Call moveDone
                            End If
                            For i = 1 To movesMaxDist: cBoard(i) = t2(i): Next
                        End If
                    End If
                Next
                If Not secondMove Then 'apperantly only one checker can be moved
                    Call moveDone
                End If
                For i = 1 To movesMaxDist: cBoard(i) = t1(i): Next
            End If
        End If
    Next
End Sub
Function tryMove(point As Integer, dice As Integer) As Boolean
    Dim hasHigher As Boolean
    Dim k As Integer
    
    tryMove = False
    If point > dice Then 'no bear off
        cBoard(point) = cBoard(point) - 1
        cBoard(point - dice) = cBoard(point - dice) + 1
        tryMove = True
    ElseIf point = dice Then ' normal bear off
        cBoard(point) = cBoard(point) - 1
        tryMove = True
    Else ' bear off if no higher point occupied
        hasHigher = False
        For k = point + 1 To movesMaxDist
            If cBoard(k) > 0 Then hasHigher = True
        Next
        If Not hasHigher Then cBoard(point) = cBoard(point) - 1: tryMove = True
    End If
End Function

Sub moveDone()
    ' requires movesmaxdist to be set
    Dim a As Integer
    Dim i As Integer
    Dim thisscore As Single
    Dim move As Long
    Dim t As Long
    Dim listed As Boolean
    a = 0
    For i = 1 To movesMaxDist: tmovedone(i) = cBoard(i): a = a + tmovedone(i): Next
    boardNr = etables(movesMaxDist, a, 0).boardNrBottom(tmovedone())
    move = boardNr + (16777216 * a)
    listed = False
    For i = 0 To moveListCount - 1
        If moveList(i) = move Then listed = True
    Next
    If Not listed Then
        moveList(moveListCount) = move
      '  Debug.Print "m" & move
        moveListCount = moveListCount + 1
    End If
    ' sort the movelist
    For i = 0 To moveListCount - 2
        For j = i + 1 To moveListCount - 1
            If moveList(i) > moveList(j) Then t = moveList(j): moveList(j) = moveList(i): moveList(i) = t
        Next
    Next
    
End Sub
Public Sub clearMoveList()
    moveListCount = 0
End Sub
