VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEquityTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'/*
' * Copyright 1999-2004 by Michel D. Grimminck
' *
' * All Rights Reserved
' *
' * Permission to use, copy, modify, and distribute this software and its
' * documentation for any purpose and without fee is hereby granted,
' * provided that the above copyright notice appear in all copies and that
' * both that copyright notice and this permission notice appear in
' * supporting documentation.
' *
' * This program is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' *
' * Please read GPL.html for the full license text.
' */

Const STOREFACTOR = 4194000#
Private fEquity() As Single
Private nBottom As Long, nTop As Long
Private eqMAXDIST As Integer
Public tableSize As Long
Private countCache(25, 15) As Long
Public isAvailable As Boolean
Private countBot As Long
Public databaseFile As String
Public isInMemory As Boolean

Public Sub save()
    Dim id As Long
    Dim ver As Long
    Dim b1 As Byte
    Dim b2 As Byte
    Dim b3 As Byte
    Dim es As Single
    
    For i = eqMAXDIST + 1 To 6
        If etables(i, nBottom, nTop).isAvailable Then Exit Sub
    Next
    id = 73457356
    ver = 100
    fname = App.Path & "\bod\1-" & eqMAXDIST & "-" & nBottom & "-" & nTop & ".bod"
    showDebug ("Saving database as " & fname)
    fn = FreeFile
    Open fname For Binary Access Write As fn
    Put #fn, , id
    Put #fn, , ver
    Put #fn, , nBottom
    Put #fn, , nTop
    For i = 0 To 4 * tableSize - 1
        es = (fEquity(i) + 2#) * STOREFACTOR + 0.5
        b1 = es And 255
        b2 = Int(es / 256#) And 255
        b3 = Int(es / 65536#) And 255
        Put #fn, , b1
        Put #fn, , b2
        Put #fn, , b3
    Next
    Close fn
End Sub
Public Sub init(cMaxDist, ncBottom, ncTop)
    nBottom = ncBottom
    nTop = ncTop
    eqMAXDIST = cMaxDist
    tableSize = countb(eqMAXDIST, nBottom) * countb(eqMAXDIST, nTop)
    countBot = countBoard(eqMAXDIST, nBottom)
End Sub
Public Sub initfile(file)
    databaseFile = file
    If Dir(file) <> "" Then isAvailable = True
End Sub
Public Sub createTable()
    Dim i As Long
    
    'If tableSize > 2000000 Then MsgBox "Large table size: " & tableSize
    ReDim fEquity(4 * tableSize)
    showDebug ("Initializing database " & nBottom & " v " & nTop & ", size=" & showBytes(tableSize * 16))
    'initialise: 99 equals unitialized
    v = 99
    If nBottom = 0 And nTop > 0 Then v = 1#
    If nBottom > 0 And nTop = 0 Then v = -1#
    For i = 0 To 4 * tableSize - 1
        fEquity(i) = v
    Next
End Sub
Public Property Get equity(boardBottom() As Integer, boardTop() As Integer, cube As Integer) As Single
    Dim Index As Long
    Index = boardNrTop(boardTop()) * countBoard(eqMAXDIST, nBottom) + boardNrBottom(boardBottom())
    
    If isInMemory Then
        equity = fEquity(4 * Index + cube)
        Exit Property
    Else
        equity = readFromFile(4 * Index + cube)
    End If
End Property
Private Function readFromFile(pos) As Single
    Dim b1 As Byte
    Dim b2 As Byte
    Dim b3 As Byte
    
    fn = FreeFile
    Open databaseFile For Binary As fn
    Get #fn, 17 + 3 * pos, b1
    Get #fn, 18 + 3 * pos, b2
    Get #fn, 19 + 3 * pos, b3
    readFromFile = (b1 + 256# * b2 + 65536# * b3) / STOREFACTOR - 2#
    'readFromFile = (b1 / 3916800# + b2 / 15300# + b3 / 60#) - 2#
    Debug.Print readFromFile
    Close fn
End Function
Public Property Get equityByNr(nrbot As Long, nrtop As Long, cube As Integer) As Single
    Index = nrtop * countBot + nrbot
    'Index = nrbot * countTop + nrtop
    equityByNr = fEquity(4 * Index + cube)
End Property
Public Property Get equityFileByNr(nrbot As Long, nrtop As Long, cube As Integer) As Single
    If nBottom > 0 And nTop = 0 Then equityFileByNr = -1: Exit Property
    If nBottom = 0 And nTop > 0 Then equityFileByNr = 1: Exit Property
    Index = nrtop * countBot + nrbot
    'Index = nrbot * countTop + nrtop
    If isInMemory Then
        equityFileByNr = fEquity(4 * Index + cube)
        Exit Property
    ElseIf isAvailable Then
        equityFileByNr = readFromFile(4 * Index + cube)
    Else
        equityFileByNr = 99
    End If
End Property

Public Property Let equityByNr(nrbot As Long, nrtop As Long, cube As Integer, value As Single)
    Index = nrtop * countBot + nrbot
    'Index = nrbot * countTop + nrtop
    fEquity(4 * Index + cube) = value
End Property
Public Property Let equity(boardBottom() As Integer, boardTop() As Integer, cube As Integer, value As Single)
    Dim Index As Long
    Index = boardNrTop(boardTop()) * countBoard(eqMAXDIST, nBottom) + boardNrBottom(boardBottom())
    fEquity(Index) = value
End Property

Public Function countBoard(distance, checkerCount) As Long
    If distance = 1 Or checkerCount = 0 Then countBoard = 1: Exit Function
    If countCache(distance, checkerCount) <> 0 Then countBoard = countCache(distance, checkerCount): Exit Function
    countBoard = 0
    For i = 0 To checkerCount
        countBoard = countBoard + countBoard(distance - 1, checkerCount - i)
    Next
    countCache(distance, checkerCount) = countBoard
End Function
Public Function boardNrTop(board() As Integer) As Long
    boardNrTop = boardNr(board(), eqMAXDIST, nTop)
End Function
Public Function boardNrBottom(board() As Integer) As Long
    boardNrBottom = boardNr(board(), eqMAXDIST, nBottom)
End Function
Public Function boardNr(ByRef board() As Integer, distance As Integer, checkerCount As Long) As Long
    Dim i As Integer
    If distance = 1 Or checkerCount = 0 Then boardNr = 0: Exit Function
    'If board(distance) = 0 Then boardNr = boardNr(board(), distance - 1, checkerCount): Exit Function
    
    boardNr = boardNr(board(), distance - 1, checkerCount - board(eqMAXDIST + 1 - distance))
    For i = 0 To board(eqMAXDIST + 1 - distance) - 1
        boardNr = boardNr + countBoard(distance - 1, checkerCount - i)
    Next
End Function
Public Sub debug1()
    cnt = 0
    For i = 0 To tableSize
        cnt = cnt + fEquity(i)
    Next
    MsgBox cnt
End Sub

Private Sub Class_Initialize()
    isAvailable = False
    isInMemory = False
End Sub
