Attribute VB_Name = "modSolve"
'/*
' * Copyright 1999-2004 by Michel D. Grimminck
' *
' * All Rights Reserved
' *
' * Permission to use, copy, modify, and distribute this software and its
' * documentation for any purpose and without fee is hereby granted,
' * provided that the above copyright notice appear in all copies and that
' * both that copyright notice and this permission notice appear in
' * supporting documentation.
' *
' * This program is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' *
' * Please read GPL.html for the full license text.
' */


Public Const CUBELESS = 0
Public Const MYCUBE = 1
Public Const OTHERCUBE = 2
Public Const CENTERCUBE = 3

Dim ml(16) As New clsMoveList
Dim blabla
Dim somecount As Long
Private bWorking As Boolean

Public Sub solveAll(MAXDIST As Integer, max)
    Dim p1 As Integer
    Dim p2 As Integer
    Dim i As Integer
    Dim tSize As Double
    If bWorking Then MsgBox "Already computing": Exit Sub
#If DEMO Then
    If MAXDIST = 6 And max > 5 Then MsgBox "Demo version allows maximum of 5 checkers": Exit Sub
#End If
    bWorking = True
    tSize = 0
    For i = 0 To max
        tSize = tSize + etables(MAXDIST, i, 0).tableSize
    Next
    showDebug ("Solving " & max & " checkers, " & tSize * tSize & " positions, " & showBytes(16 * tSize * tSize))
    For i = 1 To max
        t = Timer
        Call ml(i).createList(MAXDIST, i)
        showDebug ("Execution time: " & Format(Timer - t, "#0.00"))
    Next
    For i1 = 0 To max: For i2 = 0 To max
        If i1 = 0 Or i2 = 0 Then etables(MAXDIST, i1, i2).createTable
    Next: Next
    t = Timer
    For p1 = 1 To max: For p2 = 1 To p1
        t2 = Timer
        Call solve(MAXDIST, p1, p2)
        showDebug ("Execution time: " & Format(Timer - t2, "#0.00"))
        Call frmMain.paintBoard
    Next: Next
    showDebug ""
    showDebug ("Full execution time: " & Format(Timer - t, "#0.00"))
    showDebug ("done")
    bWorking = False
End Sub
Public Sub solve(MAXDIST As Integer, p1 As Integer, p2 As Integer)
    Dim i As Long
    Dim i1 As Long
    Dim i2 As Long
    Dim bIndex1 As Long
    Dim bIndex2 As Long
    Dim somecount As Long
#If DEMO Then
    If MAXDIST = 6 And p1 + p2 + p2 > 15 Then Exit Sub
#End If
    showDebug ("Solving " & p1 & " v " & p2 & ", distance=" & MAXDIST)
    etables(MAXDIST, p1, p2).createTable
    If p2 <> p1 Then etables(MAXDIST, p2, p1).createTable
    For i2 = 0 To ml(p2).tableSize - 1
        bIndex2 = ml(p2).xboardOrder(i2)
        For i1 = 0 To ml(p1).tableSize - 1
            bIndex1 = ml(p1).xboardOrder(i1)
            'Debug.Print bIndex2, bIndex1
            'showDebug ("Working on " & bIndex1 & " x " & bIndex2)
            Call solvePos(MAXDIST, p1, p2, bIndex1, bIndex2)
            Call solvePos(MAXDIST, p2, p1, bIndex2, bIndex1)
            somecount = somecount + 1
            If somecount = 1000 Then
                somecount = 0
                X = frmSolve.List1.Width + frmSolve.List1.Left
                frmSolve.Line (frmSolve.List1.Left, frmSolve.ScaleHeight - 4 * Screen.TwipsPerPixelY)-(X, frmSolve.ScaleHeight - Screen.TwipsPerPixelY), frmSolve.BackColor, BF
                X = CDbl(i2) * (frmSolve.List1.Width + frmSolve.List1.Left) / (ml(p2).tableSize - 1)
                frmSolve.Line (frmSolve.List1.Left, frmSolve.ScaleHeight - 4 * Screen.TwipsPerPixelY)-(X, frmSolve.ScaleHeight - Screen.TwipsPerPixelY), vbBlue, BF
                DoEvents
            End If
        Next
    Next
    etables(MAXDIST, p1, p2).isAvailable = True
    etables(MAXDIST, p1, p2).isInMemory = True
    etables(MAXDIST, p1, p2).save
    If p1 <> p2 Then
        etables(MAXDIST, p2, p1).isAvailable = True
        etables(MAXDIST, p2, p1).isInMemory = True
        etables(MAXDIST, p2, p1).save
    End If
End Sub
Private Sub solvePos(MAXDIST As Integer, p1 As Integer, p2 As Integer, bIndex1 As Long, bIndex2 As Long)
    Dim nr1 As Long
    Dim nr2 As Long
    Dim aveq0 As Single
    Dim aveq1 As Single
    Dim aveq2 As Single
    Dim aveq3 As Single
    Dim k As Integer
    Dim db As Long
    Dim eq0 As Single
    Dim eq1 As Single
    Dim eq2 As Single
    Dim eq3 As Single
    Dim besteq0 As Single
    Dim besteq1 As Single
    Dim besteq2 As Single
    Dim besteq3 As Single
    Dim bin As Long
    
    If etables(MAXDIST, p1, p2).equityByNr(bIndex1, bIndex2, CUBELESS) <> 99 Then Exit Sub
    aveq = 0
    For k = 0 To 20
        nr1 = ml(p1).xMoveIndex(bIndex1 * 21 + k)
        ' do all moves, choose best
        besteq0 = -100
        besteq1 = -100
        besteq2 = -100
        besteq3 = -100
        Do While (ml(p1).xMoveList(nr1) <> -1)
            db = CInt(ml(p1).xMoveList(nr1) / 16777216)
            bin = ml(p1).xMoveList(nr1) And 16777215
            eq0 = -etables(MAXDIST, p2, db).equityByNr(bIndex2, bin, CUBELESS)
            eq1 = -etables(MAXDIST, p2, db).equityByNr(bIndex2, bin, MYCUBE)
            eq2 = -etables(MAXDIST, p2, db).equityByNr(bIndex2, bin, OTHERCUBE)
            eq3 = -etables(MAXDIST, p2, db).equityByNr(bIndex2, bin, CENTERCUBE)
            If (2 * eq2 < eq1) Then
                If eq2 < -0.5 Then 'pass
                    eq1 = -1
                Else 'take
                    eq1 = eq2 * 2
                End If
            End If
            If (2 * eq2 < eq3) Then
                If eq2 < -0.5 Then 'pass
                    eq3 = -1
                Else 'take
                    eq3 = eq2 * 2
                End If
            End If
            If eq0 > besteq0 Then besteq0 = eq0
            If eq1 > besteq1 Then besteq1 = eq1
            If eq2 > besteq2 Then besteq2 = eq2
            If eq3 > besteq3 Then besteq3 = eq3
            nr1 = nr1 + 1
        Loop
        If k = 0 Or k = 2 Or k = 5 Or k = 9 Or k = 14 Or k = 20 Then
            aveq0 = aveq0 + besteq0 ' double throws
            aveq1 = aveq1 + besteq1 ' double throws
            aveq2 = aveq2 + besteq2 ' double throws
            aveq3 = aveq3 + besteq3 ' double throws
        Else 'single throws
            aveq0 = aveq0 + 2 * besteq0
            aveq1 = aveq1 + 2 * besteq1
            aveq2 = aveq2 + 2 * besteq2
            aveq3 = aveq3 + 2 * besteq3
        End If
    Next
    etables(MAXDIST, p1, p2).equityByNr(bIndex1, bIndex2, CUBELESS) = aveq0 / 36#
    etables(MAXDIST, p1, p2).equityByNr(bIndex1, bIndex2, OTHERCUBE) = aveq1 / 36#
    etables(MAXDIST, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) = aveq2 / 36#
    etables(MAXDIST, p1, p2).equityByNr(bIndex1, bIndex2, CENTERCUBE) = aveq3 / 36#
'    If (2 * aveq1 > aveq2) Then ' double
'        If aveq1 > 18 Then 'pass
'            etables(6, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) = 1
'        Else 'take
'            etables(6, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) = 2 * aveq1 / 36#
'        End If
'    Else
'        etables(6, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) = aveq2 / 36#
'    End If
''    If (2 * aveq2 > aveq3) Then ' double
''        If aveq2 < 18 Then 'pass
'''            etables(6, p1, p2).equityByNr(bIndex1, bIndex2, CENTERCUBE) = 1
''        Else 'take
''            If 50 * (aveq1 / 36# + 1) > 50 Then
''                showDebug (50 * (aveq1 / 36# + 1))
''            End If
''  '          etables(6, p1, p2).equityByNr(bIndex1, bIndex2, CENTERCUBE) = 2 * aveq1 / 36#
''        End If
''    Else
'' '       etables(6, p1, p2).equityByNr(bIndex1, bIndex2, CENTERCUBE) = aveq3 / 36#
''    End If

'    If etables(6, p1, p2).equityByNr(bIndex1, bIndex2, OTHERCUBE) > 1 Or etables(6, p1, p2).equityByNr(bIndex1, bIndex2, OTHERCUBE) < -1 Then
'        a = -1
'    End If
'    If etables(6, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) > 1 Or etables(6, p1, p2).equityByNr(bIndex1, bIndex2, MYCUBE) < -1 Then
'        a = -1
'    End If
End Sub
